//
//  StringExtension.swift
//  aufgabe_14_b
//
//  Created by Daniel Hoover on 10.12.16.
//  Copyright © 2016 Daniel Hoover. All rights reserved.
//

import Foundation

extension String {
    func trimOrFill(length: Int, char: Character? = nil) -> String {
        
        let lengthOfString = self.characters.count;
        
        if(lengthOfString > length) { //we need to remove chars
            //if we remove we remove one char more and add …
            
            let charToAdd: Character = "…";
            
            return self.substring(to: self.index(self.startIndex, offsetBy: (length-1))).appending(String(charToAdd));
            
            //self.index(self.startIndex, offsetBy: (length-1)) //wtf? you might say...
            /*
             
             Explained in Detail:
             
             self.startIndex is the value where String starts -> most of the time 0
             
             say we have a string "abcdefghijklmno" length is 15
             
             lets say someone wanted a length of 10
             
             the index starts at 0
             we want the index offset by 10
             
             the index will be 8 (not 9 since we have length-1) because we add a Character
             
             afterwards we append the char
             
             */
            
        } else if(lengthOfString < length) { //we need to add chars
            var index = 0;
            
            let numCharsToAdd = length - lengthOfString;
            
            var tempString = self;
            var charToAdd:Character = " "; //by default we add whitespaces...

            
            if(char != nil) {
                charToAdd = char!;
            }
            
            
            while(index < numCharsToAdd) {
                
                tempString = tempString.appending(String(charToAdd));
                
                index += 1;
            }
            
            return tempString;
        }
        
        return self; //its equal - we don't do anything
        
    }
}
